#ifndef __AC_RESULT_H_
#define __AC_RESULT_H_

#include <project.h>
#include "common/general/include/audit_mod.h"

// 访问控制的类型
enum AC_TYPE {
    AC_TYPE_MAC = 1,            // 强访
    AC_TYPE_DAC,                // 自主访问控制
    AC_TYPE_SELF,               // 自保护
    AC_TYPE_PROC,               // 进程
    AC_TYPE_KMOD,               // 内核模块
    AC_TYPE_MAC_INTERRITY,      // 强访完整性
    AC_TYPE_DIR,                // 目录访问
    AC_TYPE_FILE,               // 文件访问
    AC_TYPE_WL                 // ima中白名单文件（预留，不确定是否需要）
};

enum AC_OPE {
    AC_OPE_READ = 1,
    AC_OPE_WRITE,
    AC_OPE_EXEC,
    AC_OPE_MODIFY // todo : 注意，到底用写还是用修改？
};


// =================================================================
#pragma pack(1)
typedef struct __mac_result {
    unsigned char sub_rank;  
    unsigned char obj_rank; 
} mac_result_t;

typedef struct __ac_result {
    // unsigned int id;

    // unsigned int ac_type;

    unsigned int rule_id;

    unsigned int rule_type;  // 审计类型  如 ac -- ruleType = __POLICY_TYPE_SELF_PROTECTION;
    unsigned short sub_type; // 审计子类型 如 mac

    unsigned int ope; // 读、写、执行等

    BOOLEAN is_ban;
    BOOLEAN is_audit;

    char private[128]; // 用于不同访问控制的私有数据，暂时应该够用了

} ac_result_t;
#pragma pack()
// =================================================================

#endif
