#ifndef __AUDIT_COMM_H_
#define __AUDIT_COMM_H_

#include "common/general/include/misc/list_head.h"
#include "common/version_type.h"

typedef struct __audit_comm {
    int length;
    LIST_HEAD head;
    void (*Destroy)(struct __audit_comm *);
} audit_comm_t;

#define __destroy_audit_common(cm) \
    do {                           \
        (*(cm)->Destroy)(cm);      \
    } while (0);

static inline void set_audit_time(audit_time_t *at)
{
    struct timeval tv;

    do_gettimeofday(&tv);
    at->tv_sec = tv.tv_sec;
    at->tv_usec = tv.tv_usec;
    return;
}

#endif
