#ifndef __AUDIT_MAP_H_
#define __AUDIT_MAP_H_

#include "common/general/comm_object.h"
#include "common/general/hashtb.h"

#define __MAX_CACHE_COUNT (1024 * 10)

typedef struct __AUDIT_CACHE_HDR {
    SEC_OBJECT objHdr;
    LIST_HEAD hhead;

    LIST_HEAD chead;
    spinlock_t lock;
} audit_cache_hdr_t;

typedef struct __AUDIT_MAP {
    spinlock_t lock;
    HASHTB lookupTB;
    LIST_HEAD cacheList;
} audit_map_t;

// --------------------------------------------------
int audit_map_insert(audit_map_t *table, audit_cache_hdr_t *item);
audit_cache_hdr_t *audit_map_lookup(audit_map_t *table, void *val_ptr);

BOOLEAN audit_map_init(audit_map_t *table, HAHSTB_VALUE __get_value_ptr,
                     HAHSTB_RELEASE release_item, unsigned int valueLen);
void audit_map_clear(audit_map_t *table);
void audit_map_destroy(audit_map_t *table);


#endif
