#ifndef __AUDIT_QUEUE_H_
#define __AUDIT_QUEUE_H_

#include "audit_comm.h"
#include "common/ioctrl_param.h"

typedef struct __aduit_q {
    LIST_HEAD audit_list;
    spinlock_t lock;
    atomic_t count;

    int limit;  
} audit_q_t;

int audit_q_init(audit_q_t *queue, int limit);
void audit_q_destroy(audit_q_t *q);
void audit_q_clear(audit_q_t *q);

void audit_q_push(audit_q_t *q, audit_comm_t *common);
int audit_q_read(audit_q_t *q, IOCTL_PARAM *param);

int audit_q_read_buf(audit_q_t *queue, char __user *ubuf);

#endif
