#include "ply_switch.h"
#include "common/general/include/path_def.h"
#include "common/file_ops/file_ops.h"

BOOLEAN ply_switch_get_value(const char *ply_name, unsigned int *p_val)
{
    BOOLEAN retval = FALSE;

    struct file *fp = NULL;
    char path[128] = {0};
    char rbuf[4] = {0};

    loff_t offset = 0;
    int rbuf_len;

    *p_val = 0;

    strcpy(path, PATH_SETTING_FOLDER);
    strcat(path, "/");
    strncat(path, ply_name, sizeof(path));

    // -- O_SYNC O_CREAT O_RDWR | O_CREAT
    fp = filp_open(path, O_SYNC | O_RDONLY, 0);
    if (IS_ERR(fp)) {
        fp = NULL;
        goto DONE;
    }

    memset(rbuf, 0, sizeof(rbuf));

    rbuf_len = file_ops_read(fp, rbuf, sizeof(rbuf), &offset);
    if (rbuf_len <= 0)
        goto DONE;

    rbuf[sizeof(rbuf) - 1] = 0;

    *p_val = simple_strtol(rbuf, NULL, 10);
    
    retval = TRUE;
DONE:
    if (fp)
        filp_close(fp, NULL);

    return retval;
}

int ply_switch_get(sec_ply_switch_t *sw)
{
    int retval = -1;
    unsigned int val = 0;

    // 如果获取策略失败，则使用默认值
    if (!ply_switch_get_value(sw->key, &val)) {
        retval = 0;
        goto DONE;
    }

    tag_pr_debug("switch [%s]-[%d]\n", sw->key, val);

    sw->b_audit = (val >> 0) & 1;
    sw->b_ctrl = (val >> 1) & 1;

    tag_pr_debug("sw->b_audit [%d] sw->b_ctrl[%d]\n", sw->b_audit, sw->b_ctrl);

    retval = 0;
DONE:
    return retval;
}
