#ifndef __ELF_ASSIST_H_
#define __ELF_ASSIST_H_

#define __ELF_TYPE_O (1)
#define __ELF_TYPE_EXE (2)
#define __ELF_TYPE_SO (3)
#define __ELF_TYPE_CORE (4)

typedef struct __BINARY_INFO {
    unsigned char bits;        // -- 位数  1:32 2:64
    unsigned char byte_order;  // -- 字节序  2:大端  1:小端
    unsigned char file_type;   // -- 文件类型 1:.o  2:exe 3:.so 4:core文件
    // -- 1:可重定位文件，一般为.o文件
    unsigned char is_kern_driver;
    // -- 201:.ko
    unsigned char architecture;  // -- 架构
} BINARY_INFO;

int get_elf_info(struct file *file, unsigned char bOPS, unsigned char bReadKO,
                 BINARY_INFO *elfInfo);
int is_so_file(struct file *file, unsigned char bOPS);
int is_ko_file(struct file *file, unsigned char bOPS);
int is_bin_file(struct file *file, unsigned char bOPS);
int is_script_file_by_head(struct file *file, unsigned char bOPS);

int is_elf_file_ex(struct file *file);
int is_elf_file(struct file *file);

#endif
