#ifndef __FILE_OPS_H_
#define __FILE_OPS_H_

#include <linux/fs.h>
#include <linux/uaccess.h>
#include <linux/version.h>

struct file *file_ops_open(const char *filename, int flags, int mode);
int file_ops_close(struct file *filp, fl_owner_t id);

loff_t file_ops_get_len(struct file *file);

size_t file_ops_write(struct file *filp, char *buf, int len);

size_t file_ops_writes(struct file *file, const char *buf, size_t count);

ssize_t file_ops_read(struct file *file, char *buf, size_t count, loff_t *pos);

ssize_t file_ops_read_old(struct file *file, loff_t off, void *buf,
                          size_t count);

#endif