#ifndef __CIPHER_FILE_H_
#define __CIPHER_FILE_H_
#include "encode_ctx.h"
#include "md5.h"

#include "../common/kern_file.h"

typedef struct __CIPHER_FILE {
    KERN_FILE *fp;
    KERN_FILE __kern_file;

    MD5_CTX md5_ctx;
    ENCODE_CTX cipher_ctx;
} CIPHER_FILE;


int cipher_file_open(CIPHER_FILE *file, const kchar *path, const char *mode);
void cipher_file_close(CIPHER_FILE *file);

size_t cipher_file_read(void *buffer, size_t size, size_t count,
                        CIPHER_FILE *file);
size_t cipher_file_write(const void *buffer, size_t size, size_t count,
                         CIPHER_FILE *file);

int cipher_file_get_length(CIPHER_FILE *file, LONGLONG *pLen);

void cipher_file_fetch_md5sum(unsigned char sum[16], CIPHER_FILE *file);
int cipher_file_flush(CIPHER_FILE *file);


#endif
