#include <project.h>

#define __SM4_KEY_DATA ("NFSSECCHINA123")

#include "encode_ctx.h"

#define __ENCODE_XOR_EXHAUST(__ctx) \
    ((__ctx)->offset >= sizeof((__ctx)->jor_data))

static int __encode_ctx_init(ENCODE_CTX *ctx, cipher_crypt_ptr cipher_crypt)
{
    memset(ctx, 0, sizeof(ENCODE_CTX));
    ctx->__key = &ctx->keyCtx;
    ctx->cipher_crypt = cipher_crypt;
    // -- ctx->cipher_destroy = cipher_destroy;
    ctx->offset = sizeof(ctx->jor_data);

    return 0;
}

void encode_ctx_destroy(ENCODE_CTX *ctx)
{
    if (ctx->__key) {
        // -- ctx->encode_destroy(ctx->__key);
        ctx->__key = NULL;
    }
    return;
}

static int __encode_ctx_next(ENCODE_CTX *ctx)
{
    ULONGLONG *llPtr;
    unsigned int i;

    if (ctx->offset != sizeof(ctx->jor_data)) {
        return -1;
    }

    ctx->count++;

    llPtr = (ULONGLONG *)ctx->jor_data;
    for (i = 0; i < (__CIPHER_BLOCK_SIZE / sizeof(ULONGLONG)); i++) {
        llPtr[i] = ctx->count + (ULONGLONG)i;
    }

    (*ctx->cipher_crypt)(ctx->__key, ctx->jor_data, __CIPHER_BLOCK_SIZE);
    ctx->offset = 0;

    return 0;
}

int encode_ctx_xor(ENCODE_CTX *ctx, unsigned char *data, unsigned int length)
{
    unsigned int i;
    
    for (i = 0; i < length; i++) {
        if (__ENCODE_XOR_EXHAUST(ctx)) {
            __encode_ctx_next(ctx);
        }
        data[i] = data[i] ^ ctx->jor_data[ctx->offset];
        ctx->offset++;
    }
    
    return 0;
}

static int __encrypt(void *__key, unsigned char *jor_data, int size)
{
    sec_crypot_ctx_t *ctx = (sec_crypot_ctx_t *)__key;
    unsigned char Output[BLOCK_SIZE];

    if (size != BLOCK_SIZE) {
        return -1;
    }
    sms4_encrypt(jor_data, Output, &ctx->key);
    memcpy(jor_data, Output, BLOCK_SIZE);

    return 0;
}

int encode_ctx_init_ex(ENCODE_CTX *cipherCtx, const char *keyData, int length)
{
    __encode_ctx_init(cipherCtx, __encrypt);
    crypto_ctx_init(&cipherCtx->keyCtx, (char *)keyData, length);

    return 0;
}

int encode_ctx_init(ENCODE_CTX *cipherCtx)
{
    __encode_ctx_init(cipherCtx, __encrypt);
    crypto_ctx_init(&cipherCtx->keyCtx, (char *)__SM4_KEY_DATA,
                    strlen(__SM4_KEY_DATA));

    return 0;
}
