#ifndef __ENCODE_CTX_H_
#define __ENCODE_CTX_H_

#include "crypto_ctx.h"
//--#define __CIPHER_BLOCK_SIZE (256 / 8)
#define __CIPHER_BLOCK_SIZE (128 / 8)

typedef int (*cipher_crypt_ptr)(void *__key, unsigned char *jor_data, int size);
typedef int (*cipher_destroy_ptr)(void *__key);

typedef struct __ENCODE_CTX {
    unsigned long long count;
    unsigned char jor_data[__CIPHER_BLOCK_SIZE];
    unsigned short offset;
    void *__key;
    sec_crypot_ctx_t keyCtx;

    cipher_crypt_ptr cipher_crypt;
    // -- cipher_destroy_ptr cipher_destroy;
} ENCODE_CTX;

int encode_ctx_init_ex(ENCODE_CTX *cipherCtx, const char *keyData, int length);
int encode_ctx_init(ENCODE_CTX *ctx);
void encode_ctx_destroy(ENCODE_CTX *ctx);
int encode_ctx_xor(ENCODE_CTX *ctx, unsigned char *data, unsigned int length);

#endif
