#ifndef __SMS4_H_
#define __SMS4_H_

// notice: 这里如果不是如此定义，而是使用c中定义，会导致，应用层和内核层策略解析不一致
#define BLOCK_SIZE (16)

#pragma pack(1)
typedef struct _sms4_key {
    unsigned int m_key[4];
    unsigned int m_encrypt_rk[33];
    unsigned int m_decrypt_rk[33];
} sms4_key;

#pragma pack()

void sms4_initialize_key(sms4_key *key, unsigned char *key_str, int length);

void sms4_encrypt(unsigned char *Input, unsigned char *Output, sms4_key *key);
void sms4_decrypt(unsigned char *Input, unsigned char *Output, sms4_key *key);

void sms4_encrypt_buffer(unsigned char *Input, unsigned char *Output, int count,
                         sms4_key *key);
void sms4_decrypt_buffer(unsigned char *Input, unsigned char *Output, int count,
                         sms4_key *key);

#endif
