#ifndef __IOCTL_MOD_H_
#define __IOCTL_MOD_H_

// 内核模块和应用通信的ioctrl共享数据

typedef struct __IOCTL_DATA {
    unsigned int uCode;

    // -- unsigned char * input;
    unsigned long long input;
    unsigned int input_len;

    unsigned long long output;
    // -- unsigned char * output;
    unsigned int outputLen;
    unsigned int uRetValue;  // -- BOOL value;
    unsigned int uRawMode;
} __attribute__((packed)) SEC_IOCTL_DATA;

#define FILE_DEVICE_UNKNOWN ((unsigned int)0x1000)
#define FILE_DEVICE_PORT_CONTROL ((unsigned int)0x1001)

#define CTL_CODE(a, b, c, d) (((a) << 16) | (unsigned int)(b))

#define NFS_KMOD_IOCTL_INDEX (100)
#define __NFS_DEV_PATH "/dev/NFS_DEVOBJ"
#define __NFS_DEV_NAME "NFS_DEVOBJ"
#define __NFS_INSTALL_DEV_PATH "/dev/NFS_DEV_INST_OBJ"
#define __NFS_INSTALL_DEV_NAME "NFS_DEV_INST_OBJ"
#define __SYS_CLASS_NAME "nfs_mod_class"

#define __POLICY_TYPE_ALL (0x00)
#define __POLICY_TYPE_SELF_PROTECTION (0x01)
#define __POLICY_TYPE_SERVICE_FILE (0x02)
#define __POLICY_TYPE_PROCESS_FILE (0x03)
#define __POLICY_TYPE_SYSFOLDER_FILE (0x04)
#define __POLICY_TYPE_SYSOBJECT_FILE (0x05)
#define __POLICY_TYPE_SYSUSERINFO_FILE (0x06)
#define __POLICY_TYPE_UPDATE_FILE (0x07)
#define __POLICY_TYPE_WLFILE_PROTECTION (0x08)
#define __POLICY_TYPE_SYSBOOT_FILE (0x09)  // -- ntldr boot.ini
#define __POLICY_TYPE_XCERT_FILE (0x0A)
#define __POLICY_TYPE_STARTUP_PROTECTION (0x0B)
#define __POLICY_TYPE_SERVICE_PROTECTION (0x0C)
#define __POLICY_TYPE_SERVICEINSERT_PROTECTION (0x0D)
#define __POLICY_TYPE_MAC (0x0E)
#define __POLICY_TYPE_WHITELIST (0x0F)  // --
#define __POLICY_TYPE_AUTORUN_PROTECTION (0x10)
#define __POLICY_TYPE_FOLDER_PROTECTION (0x11)
#define __POLICY_TYPE_TRUST_FOLDER (0x12)
#define __POLICY_TYPE_FLASH_DISK (0x13)
#define __POLICY_TYPE_DEVICE_CONTROL (0x14)
#define __POLICY_TYPE_SCRIPT_PROTECTION (0x15)
#define __POLICY_TYPE_SCRIPT_WHITELIST (0x16)
#define __POLICY_TYPE_NIC_CONTROL (0x17)
#define __POLICY_TYPE_ONEKEY_REINFORCE (0x18)
#define __POLICY_TYPE_AUDIT_EXE_FOLDER (0x19)
#define __POLICY_TYPE_CDROM_DISK (0x1A)

#define __POLICY_TYPE_PROCESS_CHECK_WHITELIST \
    (0x1F)  // -- only notify kernel by ioctl
#define __POLICY_TYPE_LOGIN_CONTROL (0x21)
#define __POLICY_QUICK_PROTECTION (0x025)
#define __POLICY_TYPE_OUT_CONNECTION (0x028)
#define __POLICY_TYPE_BASELINE_SETTINGS (0x029)  // -- baseline_settings
#define __POLICY_TYPE_INTEGRITY_MAC (0x2A)
#define __POLICY_TYPE_CONFIG_FILE_CORRUPT (0x2B)
#define __POLICY_TYPE_NAC_PLY (0x2C)
#define __POLICY_TYPE_PASSWD_BRUTE_FORCE (0x2D)  // -- 密码被暴力破解
#define __POLICY_TYPE_DM (0x2E)
#define __POLICY_TYPE_KMOD (0x2F)  // 内核模块保护
#define __POLICY_TYPE_FILE (0x30)  // 普通文件保护

#define __POLICY_TYPE_COUNT (0x31)

// -- all net acess subType:
#define __SUBTYPE_NET_TCP_ACCESS (1)
#define __SUBTYPE_NET_UDP_ACCESS (2)
#define __SBUTYPE_NET_ICMP_ACCESS (3)

// -- __POLICY_QUICK_PROTECTION's subType:
#define __POLICY_QUICK_ACCOUNT_FORBIDDEN (3)

// -- event types
#define __EVENT_DISKSPACE_RUNLOW (0x2003)
#define __EVENT_DB_FILE_SPACE_RUNLOW (0x2004)

#define NFSSEC_CODE_KMOD_IOCTL                                                  \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 10, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define IOCTL_HTOOK_RELOAD_POLICY                                             \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 15, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define IOCTL_HTOOK_READ_PR_INFORMATION                                       \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 16, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_TEST                                                       \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 17, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_RELOAD_CONFIGURE_DB                                        \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 18, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_ENABLE_CHECK                                               \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 19, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_CHECKSTATE                                             \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 10, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_LOADCONIFG_STATE                                       \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 23, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_TASK_INFO                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 24, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_CONTROLMODE                                            \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 25, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_CONTROLMODE                                            \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 26, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define IOCTL_HTOOK_INSERT_TASK_INFO                                          \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 27, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define IOCTL_HTOOK_CLEAR_ALL_TASK_INFO                                       \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 28, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_RELOAD_DIGEST_DB                                           \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 29, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_PROTECT_CODE_INSERT_PID                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 30, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_PROTECT_CODE_REMOVE_PID                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 31, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_PROTECT_CODE_INSERT_TID                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 32, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_PROTECT_CODE_REMOVE_TID                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 33, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_CERTIFICATEENABLED                                     \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 34, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_CERTIFICATEENABLED                                     \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 35, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_RELOAD_GUARDFILES_DB                                       \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 36, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_SELFPROTECT_STATE                                      \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 37, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_FILEPROTECT_STATE                                      \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 38, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_GET_PROCESSPROTECT_STATE                                   \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 39, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_SELPROTECT_STATE                                       \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 40, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_FILEPROTECT_STATE                                      \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 41, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_PROCESSPROTECT_STATE                                   \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 42, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_RESET_REGISTRY_PROTECT                                     \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 43, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_VALIDATE_IMAGE_FILE                                        \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 45, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_CODE_WRITE_MESSAGE                                               \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 46, METHOD_IN_DIRECT, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_CODE_READ_MESSAGE                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 47, \
             METHOD_OUT_DIRECT,                              \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_CODE_CLEARALL_MESSAGE                                           \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 48, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_CODE_READ_AUDIT                                \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 49, \
             METHOD_OUT_DIRECT, FILE_ANY_ACCESS)

#define NFSSEC_CODE_READ_XSWITCH_VARIANTS                                       \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 50, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_XSWITCH_VARIANTS                                        \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 51, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_PID_TASK_DESC                                          \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 52, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_PROTECT_CODE_INSERT_PROTECTED_PID                                    \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 53, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_PROTECT_CODE_REMOVE_PROTECTED_PID                                    \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 54, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_PROTECT_CODE_INSERT_MSI_INSTALL_FILE                                 \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 55, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_PROTECT_CODE_REMOVE_MSI_INSTALL_FILE                                 \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 56, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_CODE_INSERT_SYS_INTEGRITY                                        \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 60, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- VALIDATE_IMAGE => VALIDATE_IMAGE_RSLT

#define NFSSEC_CODE_GET_FLASH_VOL_EVENTS                                        \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 65, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

// -- USB_VOL_INFO
#define NFSSEC_CODE_SET_FLASH_INFOS                                             \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 66, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

// -- DEV_SIGNAL
#define NFSSEC_CODE_SEND_SIGNAL                                                 \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 67, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

// -- USB_DEVICE_INFO
#define NFSSEC_CODE_INSERT_USB_DEV                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 80, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_REMOVE_USB_DEV                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 81, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_PUSH_APPLICATION_AUDIT                                      \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 84, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)  // -- for AUDIT_GEN_DATA

#define NFSSEC_CODE_SET_CDROM_RULE                                              \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 85, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_SET_ENABLE                                                  \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 86, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#define NFSSEC_CODE_READ_ENABLE                                                 \
    CTL_CODE(FILE_DEVICE_UNKNOWN, NFS_KMOD_IOCTL_INDEX + 87, METHOD_BUFFERED, \
             FILE_ANY_ACCESS)

#endif  // __IOCTL_MOD_H_