#ifndef __NFS_SYSTEM_SWITCH_H_
#define __NFS_SYSTEM_SWITCH_H_

typedef struct __sec_ply_switch sec_ply_switch_t;

typedef int (*on_switch_change_route)(sec_ply_switch_t *sw, 
                                      BOOLEAN old_ctrl, BOOLEAN old_audit);

// 开关策略的类型
enum SEC_SW_TYPE {
    SEC_SW_MIN = 100,
    SEC_SW_IMA = 101,
    // SEC_SW_DM,

    SEC_SW_MAC = 111,
    SEC_SW_NAC,
    // SEC_SW_DAC, // todo

    SEC_SW_PROT_KMOD = 121,
    SEC_SW_PROT_PROC,
    SEC_SW_PROT_FILE,
    SEC_SW_PROT_DIR,
    SEC_SW_PROT_SELF, // todo

    SEC_SW_BAN_MOD,
    SEC_SW_SOFT_REMOVE,

    SEC_SW_MAX,
};

// notice: 和内核结构体的对应
typedef struct __sec_ply_switch {
    unsigned int type;      // 策略类型
    const char *key;        // 此为策略文件名
    unsigned int b_audit : 1;
    unsigned int b_ctrl : 1;
    on_switch_change_route __on_switch_change;  // 当开关状态发生变化时,可以做一些处理
} sec_ply_switch_t;

static inline int is_sw_enable(sec_ply_switch_t * sw)
{
    return (sw->b_audit || sw->b_ctrl);
}

#endif
