#include <project.h>
#include "matchlike.h"

#define DOWNCASE(achar) \
    (((achar) >= 'A' && (achar) <= 'Z') ? (achar) + ('a' - 'A') : (achar))

typedef struct _CMP_STATE {
    unsigned short pat_index;
    unsigned short c_index;
} CMP_STATE;

#define MAX_STATE_COUNT (10)
#define WILDCARD ('*')

// -- 返回1表示匹配
int match_like(const char *pattern, int pat_len, const char *ptext, int txt_len)
{
    CMP_STATE state[MAX_STATE_COUNT];
    int state_index = -1;
    char tmp;
    int c_index = 0;
    int pat_index = 0;

    while (1) {
        if (unlikely(pat_index == pat_len)) {
            // -- 都结束就是完全匹配；
            if (c_index == txt_len) {
                return 1;
            }
            if (state_index < 0)
                return 0;

            pat_index = state[state_index].pat_index;
            c_index = state[state_index].c_index;
            state_index--;
            continue;
        }

        if (WILDCARD == pattern[pat_index]) {
            // -- 如果有通配符，则需要第归；
            if (unlikely(c_index == txt_len)) {
                for (pat_index = pat_index + 1; pat_index < pat_len;
                     pat_index++) {
                    if (WILDCARD != pattern[pat_index])
                        return 0;
                }
                return 1;
            }

            if (unlikely(state_index >= (MAX_STATE_COUNT - 1))) {
                return 0;  // --
            }

            state_index++;
            state[state_index].pat_index = pat_index;
            state[state_index].c_index = c_index + 1;
            pat_index++;
        } else {
            if (unlikely(c_index == txt_len)) {
                return 0;
            }

            tmp = ptext[c_index];
            if (tmp == pattern[pat_index]) {
                // -- "if(tmp == 0) return 1; // -- 都为0就是完全匹配；" --
                // 这句话完全没有必要;
                pat_index++;
                c_index++;
                continue;
            } else {
                if (state_index < 0)
                    return 0;

                pat_index = state[state_index].pat_index;
                c_index = state[state_index].c_index;
                state_index--;
                continue;
            }
        }
    }

    return 0;
}
