#include <project.h>

#define __PATH_SEP_CHR ('/')
#define __PATH_DOT_CHR ('.')

#define __DOT_0 (0)
#define __DOT_1 (1)
#define __DOT_2 (2)
#define __NOT_DOT (3)

#include "real_path.h"

char *__move_to_left_stop_ptr(char *stopPtr, char *limit)
{
    char *ptr;

    for (ptr = stopPtr - 1; ptr >= limit; ptr = ptr - 1) {
        if (__PATH_SEP_CHR == *ptr) {
            return ptr;
        }
    }

    return NULL;
}

char *getRealPath(char *path)
{
    int length = strlen(path);
    char *ptr;
    char *lastStopPtr = NULL;

    int left = length;
    int dot = __DOT_0;

    ptr = path;

    for (; left > 0; left--, ptr++) {
        if (__PATH_SEP_CHR == *ptr) {
            if (NULL == lastStopPtr) {
                lastStopPtr = ptr;
            } else {
                switch (dot) {
                    case __DOT_0:
                        memmove(lastStopPtr, ptr, left + 1);
                        ptr = lastStopPtr;
                        break;
                    case __DOT_1:
                        memmove(lastStopPtr, ptr, left + 1);
                        ptr = lastStopPtr;
                        break;
                    case __DOT_2:
                        lastStopPtr =
                            __move_to_left_stop_ptr(lastStopPtr, path);
                        if (!lastStopPtr) {
                            return NULL;
                        }
                        memmove(lastStopPtr, ptr, left + 1);
                        ptr = lastStopPtr;
                        break;
                    case __NOT_DOT:
                        lastStopPtr = ptr;
                        break;
                }
            }
            dot = __DOT_0;
        } else {
            if (__PATH_DOT_CHR == *ptr) {
                switch (dot) {
                    case __DOT_0:
                        dot = __DOT_1;
                        break;
                    case __DOT_1:
                        dot = __DOT_2;
                        break;
                    case __DOT_2:
                        // -- why "..."
                        dot = __NOT_DOT;
                        break;
                    case __NOT_DOT:
                    default:
                        break;
                }
            } else {
                dot = __NOT_DOT;
            }
        }
    }
    return path;
}

/*
int main(int argc, char* argv[])
{
    char path[] = "/dev/../etc/./apt/conf/../../source.list";
    if(getRealPath(path)){
        printf("<+>%s\n", path);
    }
    return 0;
}
*/
