#ifndef __SCN_CONTENT_SEARCH_H_
#define __SCN_CONTENT_SEARCH_H_
#include "comm_object.h"
#include "include/scan_machine/scan_machine.h"
#include "object_pool/object_pool.h"
#include "scan_rule_debug.h"
#include "scn_multi_match.h"

// CHECK_ROUTINE 检查例程

typedef SCN_MUL_NODE CNT_NODE;

typedef struct cnt_search_am {
    SEC_OBJECT header;
    LIST_HEAD pat_list;
    atomic_t pat_count;
    unsigned int patExtLen;  
    scan_machine_t *state_engine;
    // -- SCAN_CHECK_ROUTINE check;
} cnt_search_am_t;

#ifdef __SCN_PATTERN_DEBUG__
static __inline__ int __check_patterns(CNT_NODE *node)
{
    SCN_PATTERN *pat;
    SCN_MUL_CONTAINER *contain = node->match_keys;
    while (contain) {
        pat = (SCN_PATTERN *)contain->key_ctx;
#ifdef __SCN_PATTERN_DEBUG__
        if (pat->magic != SCN_PATTERN_MAGIC) {
            // DbgPrint("why?\n");
            return -1;
        }
#endif
        contain = contain->next;
    }
    return 0;
}
#else
#define __check_patterns(node) (0)
#endif

#endif
