#ifndef __SCN_MACHINE_H_
#define __SCN_MACHINE_H_

#include "comm_object.h"
#include "include/misc/list_head.h"
#include "object_pool/object_pool.h"
#include "scan_rule_debug.h"
#include "scan_rule_def.h"
#include "scn_node.h"

typedef struct __scn_node_opes {
    int node_ext_len;
    int (*init_node)(void *node);
    int (*destroy_node)(void *node);
    int (*insert_key)(void *node, void *key_ctx);
    
    // 得到 遍历该 node 上的所有key (如果是key_tree的话)
    void *(*traverse_key)(void *node, void *search_ctx); 

} scn_node_opes_t;

struct __scan_machine {
    SEC_OBJECT header;
    scn_node_opes_t op;

    scan_node_t *root;
    LIST_HEAD built_nodes;
    LIST_HEAD unbuild_nodes;
    unsigned int is_built;
    unsigned int is_dfa;  // 有限状态自动机
};

scan_machine_t *scan_scn_create_scan_machine(int node_ext_len, int is_dfa);

#endif
