#include <project.h>
#include "object_pool/object_pool.h"

#include "scn_machine.h"
#include "scn_node.h"
#include "statistic.h"

scan_node_t *new_scn_node(scan_machine_t *ma)
{
    scan_node_t *node =
        (scan_node_t *)kmalloc(sizeof(scan_node_t) + ma->op.node_ext_len, GFP_ATOMIC);
    
    if (unlikely(!node))
        return NULL;

    memset(node, 0, sizeof(scan_node_t) + ma->op.node_ext_len);
    
    if (ma->op.init_node) {
        ma->op.init_node(node);
    }
#ifdef __SCN_NODE_DEBUG__
    node->magic = SCN_NODE_MAGIC;
#endif
    INC_OBJ_COUNT(scan_scn_node);
    return node;
}

void delete_scn_node(scan_machine_t *ma, scan_node_t *node)
{
    if (ma->op.destroy_node) 
        ma->op.destroy_node(node);

    kfree(node);
    DEC_OBJ_COUNT(scan_scn_node);
    return;
}
