#ifndef __SCN_NODE_H_
#define __SCN_NODE_H_
#include "include/misc/list_head.h"
#include "scan_rule_debug.h"
#include "scan_rule_def.h"

// node relation
typedef struct _NODE_RL {
    scan_node_t *son_node;
    scan_node_t *brother_node;
} NODE_RL;

#define INDICES_COUNT (16)
typedef struct _TRANSFER_INFO {
    scan_node_t *nodes[INDICES_COUNT];
} TRANSFER_INFO;

typedef struct _UNBUILT_INFO {
    LIST_HEAD ub_list;
    unsigned short son_count;
} UNBUILT_INFO;

#define SCN_NODE_MAGIC (1234)

struct __scan_node {
#ifdef __SCN_NODE_DEBUG__
    unsigned int magic;
#endif

    union {
        NODE_RL relation;
        LIST_HEAD list;  // -- built_nodes
    } _u_;

    unsigned char value;
    unsigned char stop_flag : 1;  // -- 为1表示该节点表示一个字节的结束；

    union {
        TRANSFER_INFO transfer;
        UNBUILT_INFO unbuilt;
    } t;
};

// -- 判断"半字"val 是否　有后续节点，
#define NODE_BIT_IS_VALID(val, transfer) (transfer.nodes[val] != NULL)

extern void delete_scn_node(scan_machine_t *ma, scan_node_t *node);
extern scan_node_t *new_scn_node(scan_machine_t *ma);


#endif
