#ifndef __STATISTIC_H_
#define __STATISTIC_H_

#define __DO_STATISTIC

#ifdef __DO_STATISTIC
typedef struct __SCN_GLOBAL_STAT {
    atomic_t cnt_pattern_count;
    atomic_t cnt_search_am_count;
    atomic_t scan_scn_mul_container_count;
    atomic_t scan_scn_node_count;
    atomic_t scan_machine_count;
} SCN_GLOBAL_STAT;

extern SCN_GLOBAL_STAT g_stat;

// -- KPrint(MSG_LEVEL,("\t" #fi " = %d\n", atomic_read(&g_stat.fi)));

#define INC_OBJ_COUNT(x)                      \
    do {                                      \
        atomic_inc_return(&g_stat.x##_count); \
    } while (0)

#define DEC_OBJ_COUNT(x)                      \
    do {                                      \
        atomic_dec_return(&g_stat.x##_count); \
    } while (0)

void scan_scn_machine_stat(void);
#else
#define INC_OBJ_COUNT(x)
#define DEC_OBJ_COUNT(x)

#define scan_scn_machine_stat()

#endif

#endif
