#include "digest_ctx.h"
#include "sm3.h"

#ifdef HASH_ALO_SHA1
void digest_ctx_init(DIGEST_CTX *digest_ctx)
{
    sha1_starts(&digest_ctx->ctx);
}

void digest_ctx_update(DIGEST_CTX *digest_ctx, unsigned char *data, int length)
{
    sha1_update(&digest_ctx->ctx, data, length);
    return;
}

void digest_ctx_finish(DIGEST_CTX *digest_ctx, unsigned char *digest)
{
    sha1_finish(&digest_ctx->ctx, digest);
    return;
}
#else  // HASH_ALO_SM3
void digest_ctx_init(DIGEST_CTX *digest_ctx)
{
    sec_sm3_starts(&digest_ctx->ctx);
}

void digest_ctx_update(DIGEST_CTX *digest_ctx, unsigned char *data, int length)
{
    sec_sm3_update(&digest_ctx->ctx, data, length);
    return;
}

void digest_ctx_finish(DIGEST_CTX *digest_ctx, unsigned char *digest)
{
    sec_sm3_finish(&digest_ctx->ctx, digest);
    return;
}
#endif
