#ifndef __DIGEST_CTX_H_
#define __DIGEST_CTX_H_

// hash 算法选择
// #define HASH_ALO_SHA1

#ifdef HASH_ALO_SHA1
#define __DIGEST_ALGO_LENGTH (20)
#define __DIGEST_ALGO_NAME "sha1"

#include "sha1.h"

typedef struct __DIGEST_CTX {
    sha1_context ctx;
} DIGEST_CTX;

#else  // HASH_ALO_SM3

#define __DIGEST_ALGO_LENGTH (32)
#define __DIGEST_ALGO_NAME "sm3"

#include "sm3.h"

typedef struct __DIGEST_CTX {
    sm3_context ctx;
} DIGEST_CTX;

#endif

void digest_ctx_init(DIGEST_CTX *digest_ctx);
void digest_ctx_update(DIGEST_CTX *digest_ctx, unsigned char *data, int length);
void digest_ctx_finish(DIGEST_CTX *digest_ctx, unsigned char *digest);

#endif
