#ifndef __IMAGE_TABLE_H_
#define __IMAGE_TABLE_H_
#include "common/general/hashtb.h"
#include "common/general/include/format/integrity.h"
#include "include/misc/list_head.h"

typedef struct __IMAGE_HASH_TABLE {
    HASHTB *hash_table;
    spinlock_t lock;
} IMAGE_HASH_TABLE;


BOOLEAN image_table_find(HASHTB *ply_head, unsigned char *digest);

// todo: be common
static inline void digest_show(const char *hex, int len)
{
    int i = 0;
    printk(KERN_INFO "digest[");
    for (i = 0; i < len; i++) {
        if (i % 64 == 0 && i > 0) { // 超长换行
            printk(KERN_CONT " [%d]\n", i / 64);
        }
        printk(KERN_CONT "%02X", (unsigned char)*(hex + i));
    }
    printk(KERN_CONT "]\n");
    return;
}

BOOLEAN wlImageHashTableInitExt(IMAGE_HASH_TABLE *imageTable,
                                unsigned int __bucket_count);
BOOLEAN wlImageHashTableInit(IMAGE_HASH_TABLE *imageTable);
void wlImageHashTableDestroy(IMAGE_HASH_TABLE *imageTable);

BOOLEAN wlImageHashTableLookup(IMAGE_HASH_TABLE *imageTable,
                               unsigned char *image_integrity);

BOOLEAN wlImageHashTableInsert(IMAGE_HASH_TABLE *imageTable,
                               unsigned char *image_integrity,
                               unsigned char type);

BOOLEAN wlImageHashTableRemove(IMAGE_HASH_TABLE *imageTable,
                               unsigned char *image_integrity);

BOOLEAN wlImageHashTableClearAll(IMAGE_HASH_TABLE *imageTable);

BOOLEAN
wlImageHashTableClear(IMAGE_HASH_TABLE *imageTable,
                      unsigned char type);

HASHTB *wlImageHashTBCreate(void);
HASHTB *wlImageHashTBCreateExt(unsigned int __bucket_count);
BOOLEAN wlImageHashTBInsert(HASHTB *hash_table, unsigned char *image_integrity,
                            unsigned char type);
BOOLEAN wlImageHashTBUpdate(IMAGE_HASH_TABLE *imageTable,
                            HASHTB *tb); 
void wlImageHashTBDestroy(HASHTB *tb);
#endif
