#ifndef __DBGOUT_H_
#define __DBGOUT_H_

#include <linux/ctype.h>

#define __PRT_NONE ""
#define __PRT_RED ""
#define __PRT_LIGHT_RED ""
#define __PRT_GREEN ""
#define __PRT_LIGHT_GREEN ""
#define __PRT_BLUE ""
#define __PRT_LIGHT_BLUE ""
#define __PRT_DARY_GRAY ""
#define __PRT_CYAN ""
#define __PRT_LIGHT_CYAN ""
#define __PRT_PURPLE ""
#define __PRT_LIGHT_PURPLE ""
#define __PRT_BROWN ""
#define __PRT_YELLOW ""
#define __PRT_LIGHT_GRAY ""
#define __PRT_WHITE ""

#define printf DbgPrint

static void __print_hex_data_only(void *_data, int len)
{
    int i;
    int index = 0;
    int j = 0;
    unsigned char *data = (unsigned char *)_data;
    
    printf(__PRT_GREEN "NO.   ");
    for (i = 0; i < 0x10; i++) {
        printf("%.2d ", i);
        if (i == 7) {
            printf(" ");
        }
    }
    printf("\n");
    while (index < len) {
        printf(__PRT_BLUE "%.4x  ", j);
        for (i = 0; (i < 0x10) && (index < len); i++, index++) {
            if (data[index] == 0) {
                printf(__PRT_DARY_GRAY "%.2x ", (unsigned char)data[index]);
            } else {
                printf(__PRT_YELLOW "%.2x ", (unsigned char)data[index]);
            }
            if (i == 7) {
                printf(" ");
            }
        }
        j++;
        printf(__PRT_NONE "\n");
    }
    printf(__PRT_NONE);
    return;
}

static char *s_hexCode[256] = {
    "00", "01", "02", "03", "04", "05", "06", "07", "08", "09", "0A", "0B",
    "0C", "0D", "0E", "0F", "10", "11", "12", "13", "14", "15", "16", "17",
    "18", "19", "1A", "1B", "1C", "1D", "1E", "1F", "20", "21", "22", "23",
    "24", "25", "26", "27", "28", "29", "2A", "2B", "2C", "2D", "2E", "2F",
    "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "3A", "3B",
    "3C", "3D", "3E", "3F", "40", "41", "42", "43", "44", "45", "46", "47",
    "48", "49", "4A", "4B", "4C", "4D", "4E", "4F", "50", "51", "52", "53",
    "54", "55", "56", "57", "58", "59", "5A", "5B", "5C", "5D", "5E", "5F",
    "60", "61", "62", "63", "64", "65", "66", "67", "68", "69", "6A", "6B",
    "6C", "6D", "6E", "6F", "70", "71", "72", "73", "74", "75", "76", "77",
    "78", "79", "7A", "7B", "7C", "7D", "7E", "7F", "80", "81", "82", "83",
    "84", "85", "86", "87", "88", "89", "8A", "8B", "8C", "8D", "8E", "8F",
    "90", "91", "92", "93", "94", "95", "96", "97", "98", "99", "9A", "9B",
    "9C", "9D", "9E", "9F", "A0", "A1", "A2", "A3", "A4", "A5", "A6", "A7",
    "A8", "A9", "AA", "AB", "AC", "AD", "AE", "AF", "B0", "B1", "B2", "B3",
    "B4", "B5", "B6", "B7", "B8", "B9", "BA", "BB", "BC", "BD", "BE", "BF",
    "C0", "C1", "C2", "C3", "C4", "C5", "C6", "C7", "C8", "C9", "CA", "CB",
    "CC", "CD", "CE", "CF", "D0", "D1", "D2", "D3", "D4", "D5", "D6", "D7",
    "D8", "D9", "DA", "DB", "DC", "DD", "DE", "DF", "E0", "E1", "E2", "E3",
    "E4", "E5", "E6", "E7", "E8", "E9", "EA", "EB", "EC", "ED", "EE", "EF",
    "F0", "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "FA", "FB",
    "FC", "FD", "FE", "FF"};

#define __append_hex(p, y)                        \
    do {                                          \
        char *dt = s_hexCode[(unsigned char)(y)]; \
        (*p) = dt[0];                             \
        p++;                                      \
        (*p) = dt[1];                             \
        p++;                                      \
        (*p) = ' ';                               \
        p++;                                      \
    } while (0);

#define __append_char(p, y)        \
    do {                           \
        (*p) = (unsigned char)(y); \
        (p)++;                     \
    } while (0);

#define __append_string(p, y)          \
    do {                               \
        int length = strlen(y);        \
        int i;                         \
        for (i = 0; i < length; i++) { \
            (p)[i] = (y)[i];           \
        }                              \
        (p) += length;                 \
    } while (0);

static void __print_hex_data(void *_data, int len)
{
    int i;
    int index = 0;
    int j = 0;
    unsigned char *data = (unsigned char *)_data;
    char buffer[100];
    char *ptr = buffer;
    /*
    printf(__PRT_GREEN "NO.   ");

    for(i = 0; i < 0x10; i++){
        printf("%.2d ", i);
        if(i == 7) printf(" ");
    }
    printf("\n");
    */

    while (index < len) {
        int oldIndex = index;
        ptr = buffer;
        __append_hex(ptr, j);
        __append_string(ptr, "  ");
        for (i = 0; (i < 0x10) && (index < len); i++, index++) {
            __append_hex(ptr, data[index]);
            // -- printf(__PRT_DARY_GRAY "%.2x ", (unsigned char)data[index]);
            if (i == 7)
                __append_string(ptr, "  ");
        }
        for (; i < 0x10; i++) {
            // -- printf(__PRT_DARY_GRAY "   ");
            __append_string(ptr, "   ");
            if (i == 7) {
                // -- printf(" ");
                __append_string(ptr, " ");
            }
        }
        // -- printf("  ");
        __append_string(ptr, "  ");
        index = oldIndex;
        for (i = 0; (i < 0x10) && (index < len); i++, index++) {
            if (isprint(data[index])) {
                // -- __append_char((unsigned char *)ptr, (unsigned
                // char)data[index]);
                *(unsigned char *)ptr = (unsigned char)data[index];
                ptr++;
                *ptr = 0;
                // -- printf(__PRT_WHITE"%c", (char)data[index]);
            } else {
                __append_char(ptr, '.');
            }
        }
        j++;
        *ptr = 0;
        printf("%s\n", buffer);
        // -- printf(__PRT_NONE "\n");
    }
    // -- printf(__PRT_NONE);
    return;
}

#endif
