#ifndef __NFS_TABLE_H_
#define __NFS_TABLE_H_
#include "common/general/hashtb.h"
#include "pid_ctx.h"

typedef struct __NFS_LOCK {
    spinlock_t lock;
} NFS_LOCK;

typedef struct __sec_gen_table_t {
    NFS_LOCK nfs_lock;
    HASHTB lookupTB;

#ifdef __PID_GARGAGE_COLLECTION__
    LIST_HEAD gcList;
    LIST_HEAD deleteList;
#endif
} sec_gen_table_t;

extern sec_gen_table_t g_nfs_table;

extern BOOLEAN gen_module_init(void);
extern void gen_module_destroy(void);

extern PID_CONTEXT *sec_gen_insert(sec_pid_t pid);  // -- occupied a reference
extern PID_CONTEXT *sec_gen_lookup(sec_pid_t pid);  // -- occupied a reference
extern BOOLEAN sec_gen_remove(sec_pid_t pid);

#ifdef __PID_GARGAGE_COLLECTION__
extern BOOLEAN gen_table_query_delete_items(LIST_HEAD *list);
extern int nfs_table_gc(sec_gen_table_t *table);
#endif

BOOLEAN sec_gen_insert_ctx(PID_CONTEXT *ctx);

#endif
