#ifndef __NFS_TASK_TREE_H_
#define __NFS_TASK_TREE_H_
#include <linux/pid.h>
#include <linux/sched.h>

/**
 * @brief 判断进程是否在进程树中
 * 
 * @param parent 根进程pid
 * @param task 待查询的进程
 * @return int 0/1 不在/在 进程数中（出错也认为是不在）
 */
int is_child_proc(pid_t parent, struct task_struct * task);

/**
 * @brief 判断进程是否在进程树中
 * 
 * @param root_proc 根进程名
 * @param task 待查询的进程
 * @param root_pid [out] 根进程pid
 * @return int 0/1 不在/在 进程数中（出错也认为是不在）
 */
int is_child_proc_by_name(const char * root_proc, struct task_struct * task, pid_t * root_pid);

#endif