#include <project.h>
#include "script_type.h"
#include "common/sec_ext_table.h"
#include "common/elf_assist.h"
#include "common/config/sec_ply_if.h"


int is_script_proc(void)
{
    int ret = 0;

    // 临时需求，暂时去掉这些
    // if (0 == strcmp(current->comm, "bash") ||
    //     0 == strcmp(current->comm, "sh") || 
    //     0 == strcmp(current->comm, "perl") ||
    //     0 == strcmp(current->comm, "python") ||
    //     0 == strcmp(current->comm, "php") ||
    //     0 == strcmp(current->comm, "java") ||
    //     0 == strcmp(current->comm, "node") 
    //     ) {
    //     ret = 1;
    // }

    if (0 == strcmp(current->comm, "bash") ||
        0 == strcmp(current->comm, "sh")
        ) {
        ret = 1;
    }

    return ret;
}

static int __is_script_by_ext(const char * path)
{
    int retval = 0;
    char ext_buf[100] = {0};
    char *ext_p;

    sec_ply_if_t * ply_ima_ext = NULL;
    SEC_EXT_TYPE *file_type = NULL;

    ply_ima_ext = get_ply_if(SEC_PLY_IMA_EXT);
    if (!ply_ima_ext) 
        goto DONE;

    ext_p = __get_ext_name(path, ext_buf, sizeof(ext_buf));
    if (!ext_p)
        goto DONE;

    // // todo : 从策略表中查找
    file_type = sec_ext_table_lookup(ply_ima_ext->ply_head, ext_p);
    if (file_type) {
        // -- is script;
        // -- DbgPrint("[* sfCreate] script file.[%s]\n", ext_p);
        // -- DbgPrint("[* sfCreate] full-path.[%ws]\n", fullPath);
        // -- printk("[-] extension-name: isScriptFile<%s>\n", path);
        comm_object_release(file_type);
        file_type = NULL;
        retval = 1;
    }

DONE:
    return retval;
}

// 判断当前文件是否为脚本文件
// return: 0/1 no/yes
int is_script_file_type(struct file *file)
{
    int retval = 0;
    int mask = file->f_path.dentry->d_inode->i_mode & S_IXUGO;

    if ((SCRIPT_TYPE_WAY & SCRIPT_TYPE_LOGIC) == SCRIPT_TYPE_AND) {
        
        // 默认是脚本，如果检查不是，则退出
        retval = 1; 

        if (SCRIPT_TYPE_WAY & SCRIPT_BY_HEAD) {
            if (!is_script_file_by_head(file, 0)) { //todo
                retval = 0;
                goto DONE;
            }
        }
        
        if (SCRIPT_TYPE_WAY & SCRIPT_BY_PERM) {
            if (!(mask & MAY_EXEC)) {
                retval = 0;
                goto DONE;
            }
        }
        
        if (SCRIPT_TYPE_WAY & SCRIPT_BY_EXT) {
            if (!__is_script_by_ext(file->f_path.dentry->d_name.name)) {
                retval = 0;
                goto DONE;
            }
        }
        

    } else { // SCRIPT_TYPE_OR

        // 默认不是脚本，如果检查是则退出
        retval = 0; 

        if (SCRIPT_TYPE_WAY & SCRIPT_BY_HEAD) {
            if (is_script_file_by_head(file, 0)) {
                retval = 1;
                goto DONE;
            }
        }

        if (SCRIPT_TYPE_WAY & SCRIPT_BY_PERM) {
            if (mask & MAY_EXEC) {
                retval = 1;
                goto DONE;
            }
        }

        if (SCRIPT_TYPE_WAY & SCRIPT_BY_EXT) {
            if (__is_script_by_ext(file->f_path.dentry->d_name.name)) {
                retval = 1;
                goto DONE;
            }
        }
    }

DONE:
    return retval;
}

int is_script_file(struct file *file)
{
    if (!is_script_proc())
        return 0;
    
    // todo
    if (!is_script_file_type(file))
        return 0;

    return 1;
}


