#ifndef __SCRIPT_TYPE_H_
#define __SCRIPT_TYPE_H_

// 判断当前运行进程是否为脚本进程
// return: 0/1 no/yes
int is_script_proc(void);


// 判断脚文件类型的方式
#define SCRIPT_TYPE_LOGIC (1 << 3) // 判断逻辑
#define SCRIPT_BY_HEAD (1 << 2)  // 解析头
#define SCRIPT_BY_PERM (1 << 1)  // 扩展名
#define SCRIPT_BY_EXT  (1 << 0)  // 可执行权限

// 判断逻辑
#define SCRIPT_TYPE_AND  1
#define SCRIPT_TYPE_OR 0

// 头 + 可执行权限 + 扩展名
#define SCRIPT_TYPE_WAY1 (SCRIPT_TYPE_AND | SCRIPT_BY_HEAD | SCRIPT_BY_PERM | SCRIPT_BY_EXT)
// 头 + 扩展名
#define SCRIPT_TYPE_WAY2 (SCRIPT_TYPE_AND | SCRIPT_BY_HEAD | SCRIPT_BY_EXT)
// 头 或 扩展名
#define SCRIPT_TYPE_WAY3 (SCRIPT_TYPE_OR | SCRIPT_BY_HEAD | SCRIPT_BY_EXT)
// 使用此种方法
#define SCRIPT_TYPE_WAY SCRIPT_TYPE_WAY3

// 判断当前文件是否为脚本文件
// return: 0/1 no/yes
int is_script_file(struct file *file);


#endif