#ifndef __EXT_TABLE_H_
#define __EXT_TABLE_H_

#include "include/misc/list_head.h"

#include "common/general/comm_hash_table.h"
// -- #include "../common/xMutex.h"

#include "common/general/comm_object.h"

#define __MAX_EXT_NAME_LENGTH (20)

typedef struct __EXT_TYPE {
    SEC_OBJECT objHdr;
    LIST_HEAD head;
    char ext[__MAX_EXT_NAME_LENGTH];  // -- full path (long);
} SEC_EXT_TYPE;

typedef sec_hash_table_t sec_ext_table_t;

// ----------------------------------------------------------------------------------
sec_ext_table_t* sec_ext_table_init(unsigned int __count);
void sec_ext_table_clear(sec_ext_table_t *table);
void sec_ext_table_destroy(sec_ext_table_t *table);


SEC_EXT_TYPE *sec_ext_table_add(sec_ext_table_t *table, const char *ext);
BOOLEAN sec_ext_table_is_empty(sec_ext_table_t *table);

SEC_EXT_TYPE *sec_ext_table_lookup(sec_ext_table_t *table, const char *ext);

#define __FOLDER_SEPERATOR__ '/'

static inline char *__get_ext_name(const char *fileName, char *ext, int extLen)
{
    char *extPtr = NULL;
    int len = strlen(fileName);
    char *ptr = (char *)fileName;
    int i;
    int left;

    ext[extLen - 1] = 0;
    left = extLen - 1;

    if (len <= 1)
        return NULL;

    // -- ptr = ptr + len-1;

    for (i = len - 1; i >= 0 && (left > 0); i--, left--) {
        ext[left - 1] = (char)ptr[i];

        if (ptr[i] == '.') {
            extPtr = &ext[left];
            break;
        } else if (__FOLDER_SEPERATOR__ == ptr[i]) {
            break;
        }
    }
    // -- = strrchr((char * )fileName, '.');
    return extPtr;
}

static inline char *__get_ext_name_ext(const char *fileName, int count, char *ext,
                                int extLen)
{
    char *extPtr = NULL;

    int len = count;
    char *ptr = (char *)fileName;
    int i;
    int left;

    ext[extLen - 1] = 0;
    left = extLen - 1;

    if (len <= 1)
        return NULL;

    // -- ptr = ptr + len-1;

    for (i = len - 1; i >= 0 && (left > 0); i--, left--) {
        ext[left - 1] = (char)ptr[i];

        if (ptr[i] == '.') {
            extPtr = &ext[left];
            break;
        } else if (__FOLDER_SEPERATOR__ == ptr[i]) {
            break;
        }
    }
    // -- = strrchr((char * )fileName, '.');
    return extPtr;
}

#endif
