#ifndef __PATHTRIE_H_
#define __PATHTRIE_H_

#include "common/general/comm_object.h"
#include "include/misc/list_head.h"

#define PATH_TRIE_CHECK_CONTINUE (0)
#define PATH_TRIE_CHECK_BREAK (1)

typedef struct __PATH_TRIE_PATTERN {
    LIST_HEAD head;
    unsigned short nPathCount;
    void *context;
} path_trie_pattern_t;

typedef struct __PATH_TRIE path_trie_t;
typedef int (*PATH_TRIE_CHECK_ROUTINE_FUNC)(path_trie_pattern_t *pattern,
                                        char *pattern_pos, int offset, int left,
                                        void *search_context);
#define __PATH_TRIE_GET_EXT(T, pat) ((T *)((path_trie_pattern_t *)(pat) + 1))

void sec_path_trie_module_init(void);
void sec_path_trie_module_destroy(void);
void sec_path_trie_print(path_trie_t *trie);
path_trie_t *sec_path_trie_create(unsigned int __bucket_count,
                                 unsigned int patExtLen);

path_trie_pattern_t *sec_path_trie_insert(path_trie_t *trie, const char *path,
                                         unsigned int nPathCount, void *ctx);

int sec_path_trie_traverse(path_trie_t *trie, const char *path,
                           unsigned int nPathCount, unsigned int is_recursion,
                           PATH_TRIE_CHECK_ROUTINE_FUNC _check, void *search_ctx);

#endif
