#ifndef __USER_TABLE_H_
#define __USER_TABLE_H_

#include <linux/sched.h>
#include "common/general/comm_object.h"
#include "common/general/hashtb.h"
#include "common/general/include/format/integrity.h"
#include "include/misc/list_head.h"
#include "user_item.h"
#include "sec_krnl_misc.h"

BOOLEAN sec_user_table_module_init(void);
void sec_user_table_module_destroy(void);

void sec_user_table_clear(void);

sec_user_item_t *sec_user_table_lookup(SID_STOR *sid);
sec_user_item_t *sec_user_table_insert(SEC_USER_ITEM_STOR *sto);

void sec_user_table_update_hash_tb(HASHTB *lookupTB);

HASHTB *sec_user_table_create_hash_tb(void);
void sec_user_table_destroy_hash_tb(HASHTB *lookupTB);

sec_user_item_t *sec_user_table_insert_hash_tb(HASHTB *lookupTB,
                                          SEC_USER_ITEM_STOR *sto);
sec_user_item_t *sec_user_table_lookup_hash_tb(HASHTB *lookupTB, SID_STOR *sid);


extern BOOLEAN query_user_info(PID_CONTEXT *ctx);
extern BOOLEAN query_specified_user_info(PID_CONTEXT *ctx,
                                         struct task_struct *tsk);


#endif
