#ifndef __SERVICE_CHECK_TABLE_H_
#define __SERVICE_CHECK_TABLE_H_

#include "include/misc/list_head.h"

#pragma pack(1)
typedef struct __SRV_ACCESS_ITEM {
    unsigned int id;

    unsigned char isSysService : 1;     
    unsigned char isNormalProcess : 1;  
} srv_access_item_t;

#pragma pack()

BOOLEAN service_table_module_init(void);
void service_table_module_destroy(void);

void *service_access_create_trie_object(void);
int service_access_build_trie_object(void *trieObj);

BOOLEAN service_access_check(char *tftPath, unsigned int user_id,
                              srv_access_item_t *pAcItem);

void service_access_update_trie_object(void *__trie_obj);

#define PROTECT_SERVICE (3)
#define PROTECT_PROCESS (4)

BOOLEAN service_access_insert(void *__trie_obj, const char *path,
                               unsigned int id, unsigned int type);

#endif
