#ifndef __LSM_IF_H_
#define __LSM_IF_H_
#include <linux/lsm_hooks.h>
#include <linux/version.h>
#include <linux/list.h>
#include "probe.h"

// init for nfssec lsm
// return: 0/-1 success/failed
int lsm_if_init(struct security_hook_list * lsm_hooks, int nfssec_hook_size, char *lsm);
int lsm_if_exit(struct security_hook_list * lsm_hooks, int nfssec_hook_size);

// tood： 当编入内核时，想使用直接的lsm注册接口，但是行不通，会导致死机，未调通

// #ifdef NFSSEC_KMOD
// #define MY_HOOK_INIT(HEAD, HOOK)                \
//     { .head = &probe_dummy_security_hook_heads.HEAD,    \
//             .hook = { .HEAD = HOOK } }

// static inline void add_hook(struct security_hook_list *hook)
// {
//     hlist_add_tail_rcu(&hook->list, hook->head);
// }
// #else
// #define MY_HOOK_INIT(HEAD, HOOK)                \
//     LSM_HOOK_INIT(HEAD, HOOK)
// #endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(6, 6, 0)
    #define MY_HOOK_INIT(HEAD, HOOK)                \
        LSM_HOOK_INIT(HEAD, HOOK)
#else
    #define MY_HOOK_INIT(HEAD, HOOK)                \
        { .head = &probe_dummy_security_hook_heads.HEAD,    \
                .hook = { .HEAD = HOOK } }

    static inline void add_hook(struct security_hook_list *hook)
    {
        hlist_add_tail_rcu(&hook->list, hook->head);
    }
#endif

#endif