#ifndef __VFS_MOUNT_H_
#define __VFS_MOUNT_H_

#include <linux/mount.h>

#define SOCKFS_MAGIC 0x534F434B
#define SYSFS_MAGIC 0x62656572
#define TMPFS_MAGIC 0x01021994
#define DEVPTS_SUPER_MAGIC 0x1cd1
#define PROC_SUPER_MAGIC 0x9fa0

// 对于一些mount, 需要跳过
static inline int is_mount_need_check(struct vfsmount *mnt)
{
    if (!mnt || !mnt->mnt_sb)
        return 0;
    if (mnt->mnt_sb->s_magic == SOCKFS_MAGIC)
        return 0;
    if (mnt->mnt_sb->s_magic == SYSFS_MAGIC)
        return 0;
    if (mnt->mnt_sb->s_magic == TMPFS_MAGIC)
        return 0;
    if (mnt->mnt_sb->s_magic == DEVPTS_SUPER_MAGIC)
        return 0;
    if (mnt->mnt_sb->s_magic == PROC_SUPER_MAGIC)
        return 0;

    return 1;
}

#endif
