#include <linux/errno.h>
#include <project.h>

#include "common/ioctrl_param.h"
#include "ipc_handle.h"
#include "common/general/include/ioctl_mod_mac.h"
#include "common/config/sec_ply_if.h"
#include "common/audit/sec_audit.h"
#include "common/ipc/ioctl_handle.h"


static int dispatch_ioctl(struct file *filep, IOCTL_PARAM *param)
{
    int retval = -1;

    // tag_pr_info("nac got ioctl[%d]\n", param->uCode);

    switch (param->uCode) {
        case NFSSEC_CODE_READ_AUDIT:
            audit_read_ioctl(param, &g_audit_mac);
            break;

        case NFSSEC_CODE_RELOAD_PLY:
            ioctl_reload_ply(param);
            break;

        default:
            tag_pr_debug("default\n");
            break;
    }
    retval = param->uRetValue;
// DONE:
    return retval;
}

long ipc_handle_mac(struct file *filep, unsigned int cmd, unsigned long arg)
{
    int retval = 0;

    switch (cmd) {
        case NFSSEC_CODE_KMOD_IOCTL:
            retval = nfssec_ioctl_handle(filep, (void *__user)arg, dispatch_ioctl);
            break;
        default:
            retval = -EINVAL;
    }

    return retval;
}