#include <project.h>
#include <linux/fs.h>
#include <linux/miscdevice.h>
#include <linux/uaccess.h>

#include "common/general/include/ioctl_mod_mac.h"
#include "ipc_handle.h"
#include "ipc_ioctl.h"

static int __ipc_open(struct inode *inode, struct file *file)
{
    return 0;
}

static int __ipc_release(struct inode *inode, struct file *file)
{
    return 0;
}

static long __ipc_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
{
    int retval = 0;

    retval = ipc_handle_mac(file, cmd, arg);

    return retval;
}

static struct file_operations mac_dev_fops = {
    .owner = THIS_MODULE,
    .open = __ipc_open,
    .release = __ipc_release,
    .unlocked_ioctl = __ipc_ioctl,
};

static struct miscdevice nfssec_mac_device = {
    .minor = MISC_DYNAMIC_MINOR,
    .name = NFSSEC_MAC_DEV_NAME,
    .fops = &mac_dev_fops,
    .mode = 0666,
};

int ipc_init_mac(void)
{
    int retval = -1;
    int ret;

    ret = misc_register(&nfssec_mac_device);
    if (ret) {
        tag_pr_err("misc_register error, ret = %d.\n", ret);
        goto DONE;
    }

    retval = 0;
DONE:
    return retval;
}

void ipc_exit_mac(void)
{
    misc_deregister(&nfssec_mac_device);
}