#include <project.h>
#include "common/audit/audit_comm.h"
#include "common/audit/sec_audit.h"
#include "common/general/include/net_misc.h"
#include "nac_audit.h"
#include "nac_audit_map.h"

audit_q_t g_audit_nac;
static nac_aduit_map_t g_nac_aduit_map;

int nac_audit_init(void)
{
    audit_q_init(&g_audit_nac, 200);
    nac_audit_map_init(&g_nac_aduit_map);
    return 0;
}

void nac_audit_uninit(void)
{
    nac_aduit_map_destroy(&g_nac_aduit_map);
    audit_q_destroy(&g_audit_nac);
    return;
}

void nac_audit_clear_cache(void)
{
    nac_audit_map_clear(&g_nac_aduit_map);
    return;
}

int nac_audit_write(audit_q_t * audit_q, unsigned int srcIp, unsigned short srcPort,
                         unsigned int destIp, unsigned short destPort,
                         unsigned char protocol, char direction, char action)
{
    int retval = -1;
    nac_audit_item_t *item = NULL;
    // audit_comm_t *comm = NULL;

tag_pr_debug("\n");

    item = nac_audit_map_lookup(&g_nac_aduit_map, srcIp, srcPort, destIp, destPort,
                            protocol);
    if (item) {
tag_pr_debug("\n");

        retval = 0;
        goto DONE;
    }
tag_pr_debug("\n");

    item = nac_audit_item_new();
    if (!item)
        goto DONE;
tag_pr_debug("\n");

    item->key.srcIp = srcIp;
    item->key.srcPort = srcPort;
    item->key.destIp = destIp;
    item->key.destPort = destPort;
    item->key.protocol = protocol;
    item->key.direction = direction;
tag_pr_debug("\n");

    if (0 != nac_audit_map_insert(&g_nac_aduit_map, item)) 
        goto DONE;
tag_pr_debug("\n");

    audit_write_nac(audit_q, srcIp, srcPort, destIp, destPort, protocol, direction, action);
tag_pr_debug("\n");

    retval = 0;
DONE:
    // nac_audit_item_show(item);
tag_pr_debug("\n");

    // if (item) 
    //     comm_object_release(item);
    return retval;
}

NTSTATUS nac_audit_read(struct file *filep, IOCTL_PARAM *param)
{
    NTSTATUS nt_status = STATUS_SUCCESS;
    
    nt_status = audit_read_ioctl(param, &g_audit_nac);
    return nt_status;
}
