#ifndef __NAC_AUDIT_MAP_H_
#define __NAC_AUDIT_MAP_H_

#include "common/audit/audit_map.h"

// todo : 是否需要proc？？？？
#pragma pack(1)
typedef struct __nac_aduit_key {
    unsigned int srcIp;
    unsigned short srcPort;
    unsigned int destIp;
    unsigned short destPort;
    unsigned int protocol; 
    unsigned int direction; 
} __attribute__((packed)) nac_aduit_key_t;
#pragma pack()

typedef struct __nac_audit_item {
    audit_cache_hdr_t hdr;
    nac_aduit_key_t key;
} nac_audit_item_t;

typedef struct __NAC_AUDIT_MAP {
    audit_map_t map;
} nac_aduit_map_t;

void nac_audit_item_show(nac_audit_item_t * item);

int nac_audit_map_init(nac_aduit_map_t *audit_map);
void nac_aduit_map_destroy(nac_aduit_map_t *audit_map);

nac_audit_item_t *nac_audit_map_lookup(nac_aduit_map_t *audit_map, unsigned int srcIp,
                                 unsigned short srcPort, unsigned int destIp,
                                 unsigned short destPort,
                                 unsigned char protocol);
nac_audit_item_t *nac_audit_item_new(void);

int nac_audit_map_insert(nac_aduit_map_t *audit_map, nac_audit_item_t *item);
int nac_audit_map_clear(nac_aduit_map_t *audit_map);

#endif
