#ifndef __NAC_SWITCH_H_
#define __NAC_SWITCH_H_

#include <project.h>
#include "include/precomp.h"
#include "common/config/ply_switch.h"

#define NAC_SWITCH_NAME "nac"

typedef struct __nac_switch {
    atomic_t b_audit;
    atomic_t b_ctrl;
} nac_switch_t;

extern nac_switch_t g_nac_switch;

void nac_switch_init(void);
void nac_switch_uninit(void);
void nac_set_switch(NFSSEC_SWITCH_VARIANT * val);

#define IS_NAC_AUDIT() (TRUE == atomic_read(&g_nac_switch.b_audit))
#define IS_NAC_CTRL() (TRUE == atomic_read(&g_nac_switch.b_ctrl))

#endif
