
#ifndef __XC_DEBUG_LOG_QUEUE_H
#define __XC_DEBUG_LOG_QUEUE_H

#include <linux/time.h>
#include <linux/rtc.h>
#include <linux/string.h>


#define debug_log_queue_push_add_title(txt) \
            do { \
                char title[128]; \
                ktime_t k_time; \
                struct rtc_time tm; \
                k_time = ktime_get_real(); \
                tm = rtc_ktime_to_tm(k_time); \
                snprintf(title, sizeof (title) - 1, \
                "[%d-%d-%d: %d:%d:%d %s:%d] ", tm.tm_year+1900 \
                , tm.tm_mon + 1, tm.tm_mday, tm.tm_hour + 8 \
                , tm.tm_min, tm.tm_sec, __FILE__, __LINE__); \
                debug_log_queue_push(title); \
                debug_log_queue_push(txt); \
            } while (0);

#define debug_log_queue_push_switch(enable, txt) \
            if (enable) \
                debug_log_queue_push_add_title(txt)

#define printk_log(enable, ...) \
            if (enable) {\
                printk(__VA_ARGS__); \
            }

void debug_log_queue_init(int maximum);
int debug_log_queue_push(const char *txt);
int debug_log_queue_pop(char **txt);

#endif
