
#include "file_opt.h"


int file_opt_init(struct file_opt *file, const char *name)
{
    file->is_open = 0;
    file->fp = filp_open(name, O_RDWR | O_CREAT | O_APPEND,0644);
    if (IS_ERR(file->fp)){
        printk("open file error\n");
        return PTR_ERR(file->fp);
    }
    file->is_open = 1;

    return 0;
}

int file_opt_destroy(struct file_opt *file)
{
    filp_close(file->fp, NULL);
    file->is_open = 0;

    return 0;
}

int file_opt_append(struct file_opt *file, void *data, uint16_t len)
{
    loff_t pos = 0;

    if (!file->is_open) {
        return -1;
    }

    file->fs_old = get_fs();
    set_fs(KERNEL_DS);

    pos = 0;
    kernel_write(file->fp, data, len, &pos);

    set_fs(file->fs_old);

    return 0;
}
