#ifndef __USB_WLIST_H_
#define __USB_WLIST_H_
#include <linux/list.h>
#include "usb_ctrl.h"

// usb设备白名单节点
struct usb_wlist_node {
    struct list_head list;
    u32 vid;
    u32 pid;
    u32 clsid;
};

//将attr的usb数据添加到白名单中
int usb_wlist_add(struct usb_attr *attr);

//将attr数据从白名单删除
int usb_wlist_del(struct usb_attr *attr);

//从白名单找到传入参数attr的数据
//返回1找到，0未找到
int usb_wlist_find(struct usb_attr *attr);

void usb_wlist_free(void);

#endif