#include <project.h>
#include "common/config/sec_ply_if.h"
#include "nfs_syscall_hook.h"

// notice: 该文件是一层封装,如果不使用此层封装,则会导致 ply_if 中,需要调用到 syscall


static int on_switch_change(sec_ply_switch_t *sw,  BOOLEAN old_ctrl, BOOLEAN old_audit)
{
    int retval = 0;
    int b_changed = 0;

    // 状态没变化时，不需要处理
    b_changed = (old_ctrl != sw->b_ctrl) || (old_audit != sw->b_audit);
    if (!b_changed)
        goto DONE;

    tag_pr_debug("sw change audit[%d->%d] ctrl[%d->%d]\n", old_audit, sw->b_audit, old_ctrl, sw->b_ctrl);

    // 内核模块保护
    if (sw->type == SEC_SW_PROT_KMOD) {
        // 关->开 挂载系统调用
        if (!old_ctrl && !old_audit) {  
            nfs_syscall_hook_init();
        
        // 开->关 注销系统调用
        } else if (!sw->b_audit && !sw->b_ctrl) { 
            nfs_syscall_hook_exit();
        }
    }

DONE:
    return retval;
}

// 配置开关处理函数
// 目前只有 内核模块防卸载 需要
void set_sw_handle(void)
{
    sec_ply_if_t * ply = NULL;

    ply = get_ply_if(SEC_PLY_PROTECT_KMOD);
    if (!ply)
        goto DONE;

    ply->sw.__on_switch_change = on_switch_change;

DONE:    
    return;
}